--- ospfd/parse.y.orig	2009-03-31 23:03:49.000000000 +0200
+++ ospfd/parse.y	2009-04-22 15:28:51.000000000 +0200
@@ -498,6 +498,11 @@
 
 areaoptsl	: interface
 		| DEMOTE STRING	demotecount {
+#ifdef __FreeBSD__ /* XXX: FreeBSD has no carp demotion support. */
+			yyerror("FreeBSD has no CARP demotion support");
+			free($2);
+			YYERROR;
+#else
 			if ($3 < 1 || $3 > 255) {
 				yyerror("demote count out of range (1-255)");
 				free($2);
@@ -518,6 +523,7 @@
 				    area->demote_group);
 				YYERROR;
 			}
+#endif
 		}
 		| defaults
 		| STUB 			{ area->stub = 1; }
@@ -608,6 +614,11 @@
 
 interfaceoptsl	: PASSIVE		{ iface->passive = 1; }
 		| DEMOTE STRING		{
+#ifdef __FreeBSD__ /* XXX: FreeBSD has no carp demotion support */
+			yyerror("FreeBSD has no CARP demotion support");
+			free($2);
+			YYERROR;
+#else
 			if (strlcpy(iface->demote_group, $2,
 			    sizeof(iface->demote_group)) >=
 			    sizeof(iface->demote_group)) {
@@ -622,6 +633,7 @@
 				    iface->demote_group);
 				YYERROR;
 			}
+#endif
 		}
 		| defaults
 		;
